# This spec file was generated using Kpp

%define name mutella
%define ver  0.4.5
%define rel  1

Summary:   mutella is a command line/web gnutella servent
Name:      %{name}
Version:   %{ver}
Release:   %{rel}
Copyright: GPL
Vendor:    Max Zaitsev <maksik@gmx.co.uk>
Url:       http://mutella.sourceforge.net

Packager:  Max Zaitsev <maksik@gmx.co.uk>
Group:     gnutella
Source:    %{name}-%{ver}.tar.gz
# fix from Troy Engel
BuildRoot: /var/tmp/%{name}-%{ver}-build

%description
Mutella is a terminal-mode Gnutella client with an intuitive and easy to use interface.
Mutella supports all the functionality required to participate as a full-featured node
in the Gnutella network, that is supports file search, download and sharing.

Mutella is optimized for a high-bandwidth connection, it sets standards for the server
performance and stability. However, Mutella is also happy to run on a modest-speed line.

%prep
%setup
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" ./configure \
                --prefix=/usr \
                $LOCALFLAGS

%build
# Setup for parallel builds
numprocs=`egrep -c ^cpu[0-9]+ /proc/stat || :`
if [ "$numprocs" = "0" ]; then
  numprocs=1
fi

make -j$numprocs


%install
make install-strip DESTDIR=$RPM_BUILD_ROOT

cd $RPM_BUILD_ROOT
find . -type d | sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > $RPM_BUILD_DIR/file.list.mutella.tmp
find . -type f | sed 's,^\.,\%attr(-\,root\,root) ,' >> $RPM_BUILD_DIR/file.list.mutella.tmp
find . -type l | sed 's,^\.,\%attr(-\,root\,root) ,' >> $RPM_BUILD_DIR/file.list.mutella.tmp

sed 's/man.*\.[0-9]/&.gz/' $RPM_BUILD_DIR/file.list.mutella.tmp > $RPM_BUILD_DIR/file.list.mutella
rm $RPM_BUILD_DIR/file.list.mutella.tmp


%clean
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/mutella
rm -rf ../file.list.mutella


%files -f ../file.list.mutella
